/*
 * Implements a function (TestFunction) that can be called dynamically
 * from wxCLIPS.
 * To call it from CLIPS, use e.g.
 *
 * (dll-execute "dlltest.dll" "TestFunction" "an argument")
 *
 */

#include <windows.h>

//
// Global variables
//
UINT      g_cRefThisDll = 0;    // Reference count of this DLL.
HINSTANCE g_hmodThisDll = NULL;	// Handle to this DLL itself.

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        // DLL one-time initialization

        g_hmodThisDll = hInstance;
    }
    else if (dwReason == DLL_PROCESS_DETACH)
    {
    }

    return 1;   // ok
}

//---------------------------------------------------------------------------
// DllCanUnloadNow
//---------------------------------------------------------------------------

STDAPI DllCanUnloadNow(void)
{
    return (g_cRefThisDll == 0 ? S_OK : S_FALSE);
}

extern "C" char* APIENTRY TestFunction(char* arg)
{
	MessageBox(NULL, arg, "wxCLIPS DLL Test function", MB_OK);
	char* str = "123456";

	return str;
}
