/*
 * wxcdate.cc
 * wxWindows command processing: wxDate class
 *
 */

// For compilers that support precompilation, includes "wx.h".
#include "wx_prec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx.h"
#endif

#include "wx_hash.h"
#include "wx_types.h"

#if !defined(USE_IOSTREAMH) || USE_IOSTREAMH
#include <iostream.h>
#else
#include <iostream>
#endif
#include <ctype.h>
#include <stdlib.h>

#include "wx_cmds.h"
#include "wxcmdsp.h"

#ifdef USE_CLIPS
#ifndef __WATCOMC__
#include "clips.h"
#endif
#endif

extern ExtensionErrorClass ExtensionError;

#ifdef USE_CLIPS
long clipsDateCreate()
{
  if (ArgCountCheck("clipsDateCreate", AT_LEAST, 0) == -1)
    return 0;

  if (RtnArgCount() == 0)
    return wxcDateCreate();
  else
  {
    int m = (int)RtnLong(1);
    int d = 0;
    int y = 0;
    if (RtnArgCount() > 1)
      d = (int)RtnLong(2);
    if (RtnArgCount() > 2)
      y = (int)RtnLong(3);
    return wxcDateCreate(m, d, y);
  }
  return 0;
}

long clipsDateCreateJulian()
{
  if (ArgCountCheck("clipsDateCreateJulian", EXACTLY, 1) == -1)
    return 0;

  return wxcDateCreateJulian(RtnLong(1));
}

long clipsDateCreateString()
{
  if (ArgCountCheck("clipsDateCreateString", EXACTLY, 1) == -1)
    return 0;

  return wxcDateCreateString(RtnLexeme(1));
}

long clipsDateDelete()
{
  if (ArgCountCheck("clipsDateDelete", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateDelete(RtnLong(1));
}

long clipsDateAddDays()
{
  if (ArgCountCheck("clipsDateAddDays", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateAddDays(RtnLong(1), RtnLong(2));
}

long clipsDateSubtractDays()
{
  if (ArgCountCheck("clipsDateSubtractDays", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateSubtractDays(RtnLong(1), RtnLong(2));
}

long clipsDateSubtract()
{
  if (ArgCountCheck("clipsDateSubtract", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateSubtract(RtnLong(1), RtnLong(2));
}

long clipsDateAddSelf()
{
  if (ArgCountCheck("clipsDateAddSelf", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateAddSelf(RtnLong(1), RtnLong(2));
}

long clipsDateSubtractSelf()
{
  if (ArgCountCheck("clipsDateSubtractSelf", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateSubtractSelf(RtnLong(1), RtnLong(2));
}

long clipsDateLE()
{
  if (ArgCountCheck("clipsDateLE", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateLE(RtnLong(1), RtnLong(2));
}

long clipsDateLEQ()
{
  if (ArgCountCheck("clipsDateLEQ", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateLEQ(RtnLong(1), RtnLong(2));
}

long clipsDateGE()
{
  if (ArgCountCheck("clipsDateGE", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateGE(RtnLong(1), RtnLong(2));
}

long clipsDateGEQ()
{
  if (ArgCountCheck("clipsDateGEQ", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateGEQ(RtnLong(1), RtnLong(2));
}

long clipsDateEQ()
{
  if (ArgCountCheck("clipsDateEQ", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateEQ(RtnLong(1), RtnLong(2));
}

long clipsDateNEQ()
{
  if (ArgCountCheck("clipsDateNEQ", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateNEQ(RtnLong(1), RtnLong(2));
}

long clipsDateFormat()
{
  if (ArgCountCheck("clipsDateFormat", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateFormat(RtnLong(1));
}

long clipsDateSetFormat()
{
  if (ArgCountCheck("clipsDateSetFormat", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateSetFormat(RtnLong(1), RtnLexeme(2));
}

long clipsDateSetOption()
{
  if (ArgCountCheck("clipsDateSetOption", EXACTLY, 3) == -1)
    return 0;
  return (long)wxcDateSetOption(RtnLong(1), RtnLexeme(2), (Bool)RtnLong(3));
}

long clipsDateGetJulianDate()
{
  if (ArgCountCheck("clipsDateGetJulianDate", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetJulianDate(RtnLong(1));
}

long clipsDateGetDayOfYear()
{
  if (ArgCountCheck("clipsDateGetDayOfYear", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetDayOfYear(RtnLong(1));
}

long clipsDateIsLeapYear()
{
  if (ArgCountCheck("clipsDateIsLeapYear", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateIsLeapYear(RtnLong(1));
}

long clipsDateSetCurrentDate()
{
  if (ArgCountCheck("clipsDateSetCurrentDate", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateSetCurrentDate(RtnLong(1));
}

long clipsDateSetJulian()
{
  if (ArgCountCheck("clipsDateSetJulian", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateSetJulian(RtnLong(1), RtnLong(2));
}

long clipsDateSetDate()
{
  if (ArgCountCheck("clipsDateSetDate", EXACTLY, 4) == -1)
    return 0;
  return (long)wxcDateSetDate(RtnLong(1), (int)RtnLong(2), (int)RtnLong(3), (int)RtnLong(4));
}

long clipsDateAddWeeks()
{
  if (ArgCountCheck("clipsDateAddWeeks", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateAddWeeks(RtnLong(1), (int)RtnLong(2));
}

long clipsDateAddMonths()
{
  if (ArgCountCheck("clipsDateAddMonths", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateAddMonths(RtnLong(1), (int)RtnLong(2));
}

long clipsDateAddYears()
{
  if (ArgCountCheck("clipsDateAddYears", EXACTLY, 2) == -1)
    return 0;
  return (long)wxcDateAddYears(RtnLong(1), (int)RtnLong(2));
}

long clipsDateGetDay()
{
  if (ArgCountCheck("clipsDateGetDay", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetDay(RtnLong(1));
}

long clipsDateGetDaysInMonth()
{
  if (ArgCountCheck("clipsDateGetDaysInMonth", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetDaysInMonth(RtnLong(1));
}

long clipsDateGetFirstDayOfMonth()
{
  if (ArgCountCheck("clipsDateGetFirstDayOfMonth", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetFirstDayOfMonth(RtnLong(1));
}

long clipsDateGetDayOfWeek()
{
  if (ArgCountCheck("clipsDateGetDayOfWeek", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetDayOfWeek(RtnLong(1));
}

long clipsDateGetWeekOfMonth()
{
  if (ArgCountCheck("clipsDateGetWeekOfMonth", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetWeekOfMonth(RtnLong(1));
}

long clipsDateGetWeekOfYear()
{
  if (ArgCountCheck("clipsDateGetWeekOfYear", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetWeekOfYear(RtnLong(1));
}

char *clipsDateGetDayOfWeekName()
{
  if (ArgCountCheck("clipsDateGetDayOfWeekName", EXACTLY, 1) == -1)
    return (char *)AddSymbol("");

  char *s = wxcDateGetDayOfWeekName(RtnLong(1));
  if (s)
    return (char *)AddSymbol(s);
  else
    return (char *)AddSymbol("");
}

long clipsDateGetMonth()
{
  if (ArgCountCheck("clipsDateGetMonth", EXACTLY, 1) == -1)
    return 0;

  return wxcDateGetMonth(RtnLong(1));
}

long clipsDateGetYear()
{
  if (ArgCountCheck("clipsDateGetYear", EXACTLY, 1) == -1)
    return 0;

  return wxcDateGetYear(RtnLong(1));
}

char *clipsDateGetMonthName()
{
  if (ArgCountCheck("clipsDateGetMonthName", EXACTLY, 1) == -1)
    return (char *)AddSymbol("");

  char *s = wxcDateGetMonthName(RtnLong(1));
  if (s)
    return (char *)AddSymbol(s);
  else
    return (char *)AddSymbol("");
}

long clipsDateGetMonthStart()
{
  if (ArgCountCheck("clipsDateGetMonthStart", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetMonthStart(RtnLong(1));
}

long clipsDateGetMonthEnd()
{
  if (ArgCountCheck("clipsDateGetMonthEnd", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetMonthEnd(RtnLong(1));
}

long clipsDateGetYearStart()
{
  if (ArgCountCheck("clipsDateGetYearStart", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetYearStart(RtnLong(1));
}

long clipsDateGetYearEnd()
{
  if (ArgCountCheck("clipsDateGetYearEnd", EXACTLY, 1) == -1)
    return 0;
  return (long)wxcDateGetYearEnd(RtnLong(1));
}

#endif

#ifdef USE_CLIPS
void wxDateUserFunctions()
{
  DefineFunction("date-create", 'l', PTIF clipsDateCreate, "clipsDateCreate");
  DefineFunction("date-create-julian", 'l', PTIF clipsDateCreateJulian, "clipsDateCreateJulian");
  DefineFunction("date-create-string", 'l', PTIF clipsDateCreateString, "clipsDateCreateString");
  DefineFunction("date-delete", 'l', PTIF clipsDateDelete, "clipsDateDelete");
  DefineFunction("date-add-days", 'l', PTIF clipsDateAddDays, "clipsDateAddDays");
  DefineFunction("date-subtract-days", 'l', PTIF clipsDateSubtractDays, "clipsDateSubtractDays");
  DefineFunction("date-subtract", 'l', PTIF clipsDateSubtract, "clipsDateSubtract");
  DefineFunction("date-subtract-self", 'l', PTIF clipsDateSubtractSelf, "clipsDateSubtractSelf");
  DefineFunction("date-add-self", 'l', PTIF clipsDateAddSelf, "clipsDateAddSelf");
  DefineFunction("date-le", 'l', PTIF clipsDateLE, "clipsDateLE");
  DefineFunction("date-leq", 'l', PTIF clipsDateLEQ, "clipsDateLEQ");
  DefineFunction("date-ge", 'l', PTIF clipsDateGE, "clipsDateGE");
  DefineFunction("date-geq", 'l', PTIF clipsDateGEQ, "clipsDateGEQ");
  DefineFunction("date-eq", 'l', PTIF clipsDateEQ, "clipsDateEQ");
  DefineFunction("date-neq", 'l', PTIF clipsDateNEQ, "clipsDateNEQ");
  DefineFunction("date-format", 'l', PTIF clipsDateFormat, "clipsDateFormat");
  DefineFunction("date-set-format", 'l', PTIF clipsDateSetFormat, "clipsDateSetFormat");
  DefineFunction("date-set-option", 'l', PTIF clipsDateSetOption, "clipsDateSetOption");
  DefineFunction("date-get-julian-date", 'l', PTIF clipsDateGetJulianDate, "clipsDateGetJulianDate");
  DefineFunction("date-get-day-of-year", 'l', PTIF clipsDateGetDayOfYear, "clipsDateGetDayOfYear");
  DefineFunction("date-is-leap-year", 'l', PTIF clipsDateIsLeapYear, "clipsDateIsLeapYear");
  DefineFunction("date-set-current-date", 'l', PTIF clipsDateSetCurrentDate, "clipsDateSetCurrentDate");
  DefineFunction("date-set-julian", 'l', PTIF clipsDateSetJulian, "clipsDateSetJulian");
  DefineFunction("date-set-date", 'l', PTIF clipsDateSetDate, "clipsDateSetDate");
  DefineFunction("date-add-weeks", 'l', PTIF clipsDateAddWeeks, "clipsDateAddWeeks");
  DefineFunction("date-add-months", 'l', PTIF clipsDateAddMonths, "clipsDateAddMonths");
  DefineFunction("date-add-years", 'l', PTIF clipsDateAddYears, "clipsDateAddYears");
  DefineFunction("date-get-day", 'l', PTIF clipsDateGetDay, "clipsDateGetDay");
  DefineFunction("date-get-month", 'l', PTIF clipsDateGetMonth, "clipsDateGetMonth");
  DefineFunction("date-get-year", 'l', PTIF clipsDateGetYear, "clipsDateGetYear");
  DefineFunction("date-get-days-in-month", 'l', PTIF clipsDateGetDaysInMonth, "clipsDateGetDaysInMonth");
  DefineFunction("date-get-first-day-of-month", 'l', PTIF clipsDateGetFirstDayOfMonth, "clipsDateGetFirstDayOfMonth");
  DefineFunction("date-get-day-of-week", 'l', PTIF clipsDateGetDayOfWeek, "clipsDateGetDayOfWeek");
  DefineFunction("date-get-week-of-year", 'l', PTIF clipsDateGetWeekOfYear, "clipsDateGetWeekOfYear");
  DefineFunction("date-get-day-of-week-name", 's', PTIF clipsDateGetDayOfWeekName, "clipsDateGetDayOfWeekName");
  DefineFunction("date-get-month-name", 's', PTIF clipsDateGetMonthName, "clipsDateGetMonthName");
  DefineFunction("date-get-month-start", 'l', PTIF clipsDateGetMonthStart, "clipsDateGetMonthStart");
  DefineFunction("date-get-month-end", 'l', PTIF clipsDateGetMonthEnd, "clipsDateGetMonthEnd");
  DefineFunction("date-get-year-start", 'l', PTIF clipsDateGetYearStart, "clipsDateGetYearStart");
  DefineFunction("date-get-year-end", 'l', PTIF clipsDateGetYearEnd, "clipsDateGetYearEnd");
}
#endif
